//#########################################################################
// File: dos.h
//
//
//#########################################################################
// Last change: 09.05.2004
//#########################################################################
// Compiler: AVR-GCC 3.2
//#########################################################################

#ifndef __DOS_H
#define __DOS_H

#if defined(__arm__) || defined(__thumb__)

 #include "typedefs.h" // ARM specific types

#elif defined(__AVR__) || defined(ATMEGA)

// Do it in dos.h or make an avrtypes.h and include it here
 typedef unsigned char U8;  // one byte
 typedef unsigned int U16;   // two bytes
 typedef unsigned long U32;  // four bytes

#endif

#define F_ERROR		0 // dir/file operation failed
#define F_OK		1 // dir/file operation successfull

#define filelength()	FileSize

extern unsigned char ReadFileRaw(char *name);
extern unsigned char FindName(char *name);

//this is for easier and faster converting from byte arrays to UINT, ULONG
//ui and ul share the same memory space
union Convert {
 U16  ui;
 unsigned long ul;
};

#include "media.h"   // select flash medium (CF, MMC, SD, ...)
#include "mydefs.h"  // keep the line at this place ! don't move down or delete 

#ifdef COMPACTFLASH_CARD
 #include "compact.h"
#endif

#ifdef MMC_CARD_SPI
 #include "mmc_spi.h"
#endif

#include "fat.h"
#include "dir.h"

#endif //__DOS_H
